        .model small
        .586
        .stack 200h
        .code
; -------------------------------------------------------------------------
; al contains the character read.
;
        public  _ReadChar
_ReadChar  proc
        mov   ah,01h
        int   33
        ret	
_ReadChar endp
; -------------------------------------------------------------------------
; dl contains the character to be printed.
;
        public  _PrintChar
_PrintChar  proc
        push  ax
        mov   ah,02h
        int   33
        pop   ax
        ret	
_PrintChar endp
; -------------------------------------------------------------------------
; bp+6 the dividend
; bp+4 number 10 (divisor)
; bp-1 till bp-5 the positions for the digits indexed by si.
;
        public  _PrintInt
_PrintInt  proc    
        push  bp
        mov   bp,sp
        sub   sp,6                ; for the digits of the number.
        push  ax
        push  dx
        push  si
        mov   si,0                ; keeps the next digit position.
        mov   ax,word ptr [bp+6]  ; address of number to be printed.
        or    ax,ax
        jge   @1                  ; goto @1 if number >= 0, thus positive or 0.
        mov   dl,'-' 
        call _PrintChar
        neg   ax                  ; make number positive.
        jmp   @2
@1:     jg    @2                  ; goto @2 if number > 0.
        mov   dl,'0'              ; thus print zero.
        call _PrintChar
        jmp   @10                 ; goto telos
                  ;
@2:               ; ax contains the dividend
                  ;
        cwd
        div   word ptr [bp+4]     ; divide by 10.
        dec   si
        mov   [bp+si],dl          ; remainder (the digit) on stack.
        or    ax,ax
        jnz   @2
@3:     mov   dl,[bp+si]          ; Display the digits.
        add   dl,'0'              ; Make the digit an ASCII character.
        call _PrintChar
        inc   si
        or    si,si
        jnz   @3
                  ;
@10:              ; just print newline after the number.
                  ;
        mov   dl,13              ; 13=ASCII code CR 
        call _PrintChar
        mov   dl,10              ; 10=ASCII code LF 
        call _PrintChar
        pop   si
        pop   dx
        pop   ax
        mov   sp,bp
        pop   bp
        ret	
_PrintInt endp
; ---------------------------------------------------------
; Reads only integers, i.e. any sequence of decimal digits
; preffixed by '-','+' or no sign terminated by enter. Any 
; other character makes it start from the beginning.
; Returns with the just read integer in the ax register.
;
        public  _ReadInt
_ReadInt  proc    
        push  bp
        mov   bp,sp
        sub   sp,2           ; 1 if positive, -1 if negative.
        push  dx
        push  bx
        mov   word ptr [bp-2],1
@20:    Call _ReadChar
        cmp   al,'-'
        jne   @21
        mov   word ptr [bp-2],-1
        jmp   @23
@21:    cmp   al,'+'
        mov   bx,0
        jne   @24
@23:    Call _ReadChar
@24:    cmp   al,'0'
        jl    @25            ; jump if less than '0'.
        cmp   al,'9'         
        jg    @26            ; jump if greater than '9'.
        imul  bx,10          ; Otherwise, 
        mov   ah,0           ;  .
        sub   ax,'0'         ;  .
        add   bx,ax          ;  .
        jmp   @23            ; accepted and read next character. 
@25:    cmp   al,13          ; Is it a CR
        je    @30            ; so end it.
@26:    mov   dl,13          ; Print CR 
        call _PrintChar
        mov   dl,10          ; Print LF 
        call _PrintChar
        mov   dl,'?' 
        call _PrintChar
        mov   dl,' ' 
        call _PrintChar
        jmp   @20            ; ERROR, reread the integer. 
@30:    mov   dl,13          ; Print CR 
        call _PrintChar
        mov   dl,10          ; Print LF 
        call _PrintChar
        imul  bx,[bp-2]      ; Put the sign.
        mov	  ax,bx          ; Return with integer in ax.
	  pop   bx
        pop   dx
	  mov   sp,bp
	  pop   bp
	  ret	
_ReadInt endp
;        end

main proc
        mov dl,'?'
        call _PrintChar
        call _ReadInt
        mov  ah,4ch
        int 21h
main endp
     end main
     end